## pakcs 3.3.0

=== Makefile ===
#****************************************************************************
# PAKCS: The Portland Aachen Kiel Curry System
# ============================================
#
# A Prolog-based implementation of the functional logic language Curry
# developed by
#
# Sergio Antoy, Bernd Brassel, Martin Engelke, Michael Hanus, Klaus Hoeppner,
# Johannes Koj, Philipp Niederau, Ramin Sadre, Frank Steiner
#
# (contact: pakcs@curry-lang.org)
#****************************************************************************

# Some parameters for this installation
# --------------------------------------
# (these parameters might be passed to `make`)

# If the parameter CURRYFRONTEND is set to an executable,
# this executable will be used as the front end for PAKCS.
# Otherwise, the front end will be compiled from the sources
# in subdir "frontend" (if it exists).
export CURRYFRONTEND =

# Is this an installation for a distribution (Debian) package (yes|no)?
# In case of "yes":
# - nothing will be stored during the installation in the home directory
# - the documentation will not be built (since this takes a lot of time)
# - the paramters CURRYLIBSDIR and CURRYTOOLSDIR must be defined and
#   refer to the directories containing the Curry system libraries and tools
export DISTPKGINSTALL = no

# Set to true during CI build
export CI_BUILD = no

# In order to build the system in a place different from the place of
# the final installation (e.g., when building it as a (Debian) package),
# the variable PAKCSINSTALLDIR should be set to the location where it
# will be finally installed after the build (e.g., /usr/lib/pakcs).
# It is required that during the build, this directory does not exist,
# otherwise the build fails. If this variable is set and the
# installed system will be moved to this location after the build, it will be
# used as the root directory for all generated components of the system.
export PAKCSINSTALLDIR =

########################################################################
# The name of the Curry system, needed for the installation of
# the system libraries and tools:
export CURRYSYSTEM=pakcs

# The major version number:
export MAJORVERSION=3
# The minor version number:
export MINORVERSION=3
# The revision version number:
export REVISIONVERSION=0
# The build version number (if >0, then it is a pre-release)
BUILDVERSION=0
# Complete version:
export VERSION=$(MAJORVERSION).$(MINORVERSION).$(REVISIONVERSION)
# The version date:
ifeq ($(DISTPKGINSTALL),yes)
COMPILERDATE := $(shell date "+%Y-%m-%d")
else
COMPILERDATE := $(shell git log -1 --format="%ci" | cut -c-10)
endif

# Paths used in this installation
# -------------------------------

# the root directory of the installation
export ROOT=$(CURDIR)

# Directories of the sources of the standard libraries and tools
ifeq ($(DISTPKGINSTALL),yes)
export CURRYLIBSDIR  = $(error "CURRYLIBSDIR is undefined!")
export CURRYTOOLSDIR = $(error "CURRYTOOLSDIR is undefined!")
else
export CURRYLIBSDIR  = $(ROOT)/lib-trunk
export CURRYTOOLSDIR = # not used
endif

# binary directory and executables
export BINDIR=$(ROOT)/bin
# Directory where the front end is located
export FRONTENDDIR   = $(ROOT)/frontend
# Directory where the actual libraries are located
export LIBDIR        = $(ROOT)/lib
# Directory where the documentation files are located
export DOCDIR        = $(ROOT)/docs

# The file containing the version number of the base libraries:
BASEVERSIONFILE = $(LIBDIR)/VERSION

# Executable of CurryCheck:
CURRYCHECK := $(shell which curry-check)
# Executable of CurryDoc:
CURRYDOC := $(shell which curry-doc)
# Executable of the markdown translator (required for documentation generation):
MD2PDF := $(shell which md2pdf)

# The version information file for PAKCS:
PAKCSVERSION=$(ROOT)/src/pakcsversion.pl
# The version information file for the manual:
MANUALVERSION=$(DOCDIR)/src/version.tex

# Various executables used in the installation
# --------------------------------------------

# The REPL binary, used for building various tools
export REPL         = $(BINDIR)/$(CURRYSYSTEM)
# The default options for the REPL
export REPL_OPTS    = --noreadline :set -time
# The front end binary
export CYMAKE       = $(BINDIR)/$(CURRYSYSTEM)-frontend
# The cleancurry binary
export CLEANCURRY   = $(BINDIR)/cleancurry

# Logfile for make:
MAKELOG=make.log

########################################################################
# The targets
########################################################################

#
# Install all components of PAKCS
#
.PHONY: all
all:
ifeq ($(DISTPKGINSTALL),yes)
	$(MAKE) config
	$(MAKE) build
	# if we build a package, we compile all libraries at the end
	# so that their intermediate files are up to date:
	$(REPL) --nocypm $(REPL_OPTS) :load AllLibraries :eval "3*13+3" :quit
else ifeq ($(CI_BUILD),yes)
	# don't need the log file and the pipe swallows non 0 exit codes
	$(MAKE) config
	$(MAKE) build
else
	@rm -f $(MAKELOG)
	@echo "Make started at `date`" > $(MAKELOG)
	$(MAKE) config 2>&1 | tee -a $(MAKELOG)
	$(MAKE) build  2>&1 | tee -a $(MAKELOG)
	@echo "Make finished at `date`" >> $(MAKELOG)
	@echo "Make process logged in file $(MAKELOG)"
endif

# Check whether the value of PAKCSINSTALLDIR, if defined, is a non-existing
# directory
.PHONY: checkinstalldir
checkinstalldir:
	@if [ -n "$(PAKCSINSTALLDIR)" -a -d "$(PAKCSINSTALLDIR)" ] ; then \
	  echo "ERROR: Variable PAKCSINSTALLDIR points to an existing directory!" && exit 1 ; \
	fi

#
# Build all components of PAKCS
#
.PHONY: build
build: checkinstalldir
	$(MAKE) kernel
	$(MAKE) tools
ifneq ($(CI_BUILD),yes)
	$(MAKE) manual
endif
	chmod -R go+rX .

# install the kernel system (binaries and libraries)
.PHONY: kernel
kernel: scripts copylibs copytools
	# install front end:
	$(MAKE) frontend
	# pre-compile all libraries:
	$(MAKE) -C lib fcy
	# build the PAKCS compiler as a saved system:
	$(MAKE) $(PAKCSVERSION)
	$(MAKE) -C src
	# compile optimization tools:
	@$(MAKE) -C currytools/optimize
	# compile all libraries:
	$(MAKE) -C lib AllLibraries.curry
	scripts/compile-all-libs.sh
	# prepare for separate compilation: compile all libraries to Prolog
	@if [ -r bin/pakcs ] ; then $(MAKE) -C lib pl ; fi

# build the PAKCS compiler and REPL as an executable:
.PHONY: repl
repl:
	cd src && $(MAKE)

# Clean old files that might be in conflict with newer versions of PAKCS:
.PHONY: cleanoldinfos
cleanoldinfos:
	# delete old RequiredValue analysis files since format has changed:
	@if [ -d $(HOME)/.curry/Analysis ] ; then \
	  find $(HOME)/.curry/Analysis -name \*.RequiredValue.p\* -exec rm -f \{\} \; ; fi

# Configure installation, i.e., set the Prolog back end and install scripts:
.PHONY: config
config: scripts
	@scripts/configure-prolog.sh

# install the scripts of PAKCS in the bin directory:
.PHONY: scripts
scripts:
	cd scripts && $(MAKE) all

# remove the scripts of PAKCS in the bin directory:
.PHONY: cleanscripts
cleanscripts:
	cd scripts && $(MAKE) clean

# install the library sources from the trunk directory:
.PHONY: copylibs
copylibs:
	@if [ -d $(CURRYLIBSDIR) ] ; then \
	  $(MAKE) -f $(ROOT)/Makefile_install_lib ; \
	  $(MAKE) $(LIBDIR)/Makefile ; fi

$(LIBDIR)/Makefile: lib_Makefile
	mkdir -p $(LIBDIR)
	cp $< $@

# if the directory `currytools` is not present, copy it from the sources:
# (only necessary for the installation of a (Debian) packages, otherwise
# `currytools` is a submodule of the repository)
.PHONY: copytools
copytools:
ifeq ($(DISTPKGINSTALL),yes)
	@if [ ! -f currytools/Makefile ] ; then $(MAKE) forcecopytools ; fi
endif

.PHONY: forcecopytools
forcecopytools:
	mkdir -p currytools
	# Copying currytools from $(CURRYTOOLSDIR)
	cp -pr $(CURRYTOOLSDIR)/* currytools

# install front end (from environment variable or sources):
.PHONY: frontend
frontend:
ifeq ($(shell test -x "$(CURRYFRONTEND)" ; echo $$?),0)
	rm -f $(CYMAKE)
	ln -s $(CURRYFRONTEND) $(CYMAKE)
else
	@if [ -d $(FRONTENDDIR) ] ; then $(MAKE) compilefrontend ; fi
endif

.PHONY: compilefrontend
compilefrontend:
	rm -f $(CYMAKE)
	cd $(FRONTENDDIR) && $(MAKE)
	cd $(BINDIR) && ln -s ../frontend/bin/curry-frontend $(notdir $(CYMAKE))

# compile the tools:
.PHONY: tools
tools:
	@if [ -r bin/pakcs ] ; then $(MAKE) -C currytools ; fi

# compile documentation if sources are available and it is not a
# separate package distribution:
.PHONY: manual
manual:
ifeq ($(CI_BUILD),yes)	
	@if [ -d $(DOCDIR)/src -a $(DISTPKGINSTALL) = "no" ] ; then \
		if [ -x "$(CURRYDOC)" -a -x "$(MD2PDF)" ] ; then \
			$(MAKE) $(MANUALVERSION) && cd $(DOCDIR)/src && $(MAKE) install ; \
		else \
			echo "Executable 'curry-doc' or 'md2pdf' not found!" ; \
	        echo "To generate the manual, install them by:" ; \
			echo "> cypm install currydoc && cypm install markdown" ; \
			exit 1 ; \
		fi \
	fi
else	
	@if [ -d $(DOCDIR)/src -a $(DISTPKGINSTALL) = "no" ] ; then \
	   if [ -x "$(CURRYDOC)" -a -x "$(MD2PDF)" ] ; then \
	     $(MAKE) $(MANUALVERSION) && cd $(DOCDIR)/src && $(MAKE) install ; \
	   else \
			echo "Executable 'curry-doc' or 'md2pdf' not found!" ; \
			echo "To generate the manual, install them by:" ; \
			echo "> cypm install currydoc && cypm install markdown" ; \
		fi \
	fi
endif

# Create file with version information for PAKCS:
$(PAKCSVERSION): Makefile $(BASEVERSIONFILE)
	echo ':- module(pakcsversion,[compilerVersion/1, compilerMajorVersion/1, compilerMinorVersion/1, compilerRevisionVersion/1, buildVersion/1, buildDate/1, buildDir/1, pkgInstallDir/1, baseVersion/1]).' > $@
	echo "compilerVersion('PAKCS$(MAJORVERSION).$(MINORVERSION)')." >> $@
	echo 'compilerMajorVersion($(MAJORVERSION)).' >> $@
	echo 'compilerMinorVersion($(MINORVERSION)).' >> $@
	echo 'compilerRevisionVersion($(REVISIONVERSION)).' >> $@
	echo 'buildVersion($(BUILDVERSION)).' >> $@
	echo "buildDate('$(COMPILERDATE)')." >> $@
	echo "buildDir('$(ROOT)')." >> $@
	echo "pkgInstallDir('$(PAKCSINSTALLDIR)')." >> $@
	echo "baseVersion('$(shell cat $(BASEVERSIONFILE))')." >> $@

# Create file with version information for the manual:
$(MANUALVERSION): Makefile
	echo '\\newcommand{\\pakcsversion}{$(VERSION)}' > $@
	echo '\\newcommand{\\pakcsversiondate}{Version of $(COMPILERDATE)}' >> $@

#
# Create documentation for system libraries:
#
.PHONY: libdoc
libdoc:
ifeq ($(CI_BUILD),yes)
	@if [ ! -x "$(CURRYDOC)" ] ; then \
		echo "Executable 'curry-doc' is not installed!" ; \
		echo "Install it by > cpm install currydoc" ; \
		exit 1 ; \
	else \
		$(MAKE) genlibdoc ; \
	fi
else
	@if [ ! -x "$(CURRYDOC)" ] ; then \
		echo "Executable 'curry-doc' is not installed!" ; \
		echo "Install it by > cpm install currydoc" ; \
	else \
		$(MAKE) genlibdoc ; \
	fi
endif

.PHONY: genlibdoc
genlibdoc:
ifeq ($(CI_BUILD),yes) 
	$(MAKE) -C lib htmldoc
else
	@rm -f $(MAKELOG)
	@echo "Make libdoc started at `date`" > $(MAKELOG)
	$(MAKE) -C lib htmldoc 2>&1 | tee -a ../$(MAKELOG)
	@echo "Make libdoc finished at `date`" >> $(MAKELOG)
	@echo "Make libdoc process logged in file $(MAKELOG)"
endif

########################################################################
# Testing: run test suites to check the installation
#
ifeq ($(DISTPKGINSTALL),yes)
# for a package installation, we run the tests in verbose mode:
export RUNTESTPARAMS=-v
else
export RUNTESTPARAMS=
endif

# run the test suites to check the installation
.PHONY: runtest
runtest:
ifeq ($(CI_BUILD),yes)
	@if [ ! -x "$(CURRYCHECK)" ] ; then \
		echo "Executable 'curry-check' is not installed!" ; \
		echo "To run the tests, install it by > cypm install currycheck" ; \
		exit 1 ; \
	else \
		$(MAKE) runalltests ; \
	fi
else
	@if [ ! -x "$(CURRYCHECK)" ] ; then \
		echo "Executable 'curry-check' is not installed!" ; \
		echo "To run the tests, install it by > cypm install currycheck" ; \
	else \
		$(MAKE) runalltests ; \
	fi
endif

.PHONY: runalltests
runalltests: testsuite/test.sh
	cd testsuite && ./test.sh $(RUNTESTPARAMS)
	$(MAKE) -C currytools runtest
	# remove .curry (might contain analysis results if home is missing)

=== scripts/Makefile ===
##############################################################################
# Installation of PAKCS shell scripts
##############################################################################

# the scripts to be installed
BINS = $(BINDIR)/pakcs $(BINDIR)/cleancurry $(BINDIR)/pakcs-fcypp


.PHONY: all
all:
	@if [ ! -d $(BINDIR) ] ; then mkdir -p $(BINDIR) ; fi
	$(MAKE) $(BINS)

# install some script of PAKCS in the bin directory:
$(BINDIR)/%: %.sh
	mkdir -p $(@D)
	cat $< | \
	 sed "s|^PAKCSBUILDDIR=.*$$|PAKCSBUILDDIR=$(ROOT)|" | \
	 sed "s|^PAKCSINSTALLDIR=.*$$|PAKCSINSTALLDIR=$(PAKCSINSTALLDIR)|" | \
	 sed "s|^COMPILERVERSION=.*$$|COMPILERVERSION=$(CURRYSYSTEM)-$(VERSION)|" > $@
	chmod 755 $@

.PHONY: clean
clean:
	rm -f $(BINS)

=== src/Makefile ===
########################################################################
# Makefile for the Curry->Prolog compiler system of PAKCS
########################################################################

# bin directory to store executables of PAKCS:
ifndef BINDIR
BINDIR = $(dir $(CURDIR))/bin
endif

# The SICStus Prolog system:
SICSTUS=$(BINDIR)/sicstusprolog

# The SWI-Prolog system:
SWI=$(BINDIR)/swiprolog

# Standard options for SWI-Prolog: quiet and optimized compilation
SWIOPTIONS=-q -O
# If there is a local stack overflow during compilation (e.g., reported
# by a message like "ERROR: local"), one should increase the stack sizes
# by redefining this definition according to version of SWI-Prolog:
# SWI-Prolog 7.*: use 2GB for the local stack:
#SWIOPTIONS=-q -L2G -G0 -T0 -O
# SWI-Prolog 8.*: use 4GB for all stacks:
#SWIOPTIONS=-q --stack_limit=4g -O

# library directory of PAKCS:
ifndef LIBDIR
LIBDIR = $(dir $(CURDIR))/lib
endif

# names of run-time libraries:
PRIMLIBSRC = `cd lib_src && echo *.pl`

.PHONY: install
install:
	$(MAKE) uninstall
	@if [ -x "$(SICSTUS)" ] ; then $(MAKE) sicstus ; elif [ -x "$(SWI)" ] ; then $(MAKE) swi ; else echo "No Prolog defined to generate Curry->Prolog compiler" ; exit 1 ; fi
	../scripts/makesavedstate c2p.state
	rm -f pakcs
	mv c2p.state pakcs
	cd $(BINDIR) && ln -s pakcs curry

.PHONY: uninstall
uninstall:
	rm -f $(BINDIR)/curry

# make everything if we have a SICStus-Prolog system:
.PHONY: sicstus
sicstus:
	echo "[sicstusbasics], generatePrologBasics." | "$(SICSTUS)"
	$(MAKE) c2p.state

# make everything if we have a SWI-Prolog system:
.PHONY: swi
swi:
	rm -f prologbasics.pl ; cp swibasics.pl prologbasics.pl
	$(MAKE) swi.state
	mv -f swi.state c2p.state

#
# generate a saved state of the Curry->Prolog Compiler System w.r.t. SICStus-Prolog
#
c2p.state: prologbasics.pl basics.pl version.pl loader.pl evaluator.pl c2p.pl \
	      compiler.pl external.pl readPrimFile.pl readFlcFromFcy.pl \
	      readXml.pl $(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude.fcy
	echo "compile(c2p),c2p('$(LIBDIR)/Prelude'),compile('$(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude'),loadAndCompile('$(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude.pl',[],create),saveprog_entry('c2p.state',user:pakcsMain)." \
           | "$(SICSTUS)"

#
# generate a saved state of the Curry->Prolog Compiler System w.r.t. SWI-Prolog
#
swi.state: prologbasics.pl basics.pl version.pl loader.pl evaluator.pl c2p.pl \
	      compiler.pl external.pl readPrimFile.pl readFlcFromFcy.pl \
	      readXml.pl $(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude.fcy
	echo "compile(c2p). c2p('$(LIBDIR)/Prelude'), compile('$(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude'),loader:loadAndCompile('$(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude.pl',[],create). saveprog_entry('swi.state',user:pakcsMain)." | "$(SWI)" $(SWIOPTIONS)

$(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude.fcy: $(LIBDIR)/Prelude.curry
	cd $(LIBDIR) && $(MAKE) .curry/pakcs-$(VERSION)/Prelude.fcy

# clean up everything
.PHONY: clean
clean: uninstall
	rm -f c2p.state pakcs $(LIBDIR)/.curry/pakcs-$(VERSION)/Prelude.pl prologbasics.pl
	rm -f pakcsversion.pl

=== docs/src/Makefile ===
# To format the user manual

PAKCS=../../bin/pakcs

# Executable of the markdown translator:
MD2PDF := $(shell which md2pdf)

.PHONY: pdf
pdf : manual.pdf

manual.pdf: $(wildcard *.tex lib/*.tex tooldocs/*/*.tex)
	pdflatex manual
	bibtex manual
	pdflatex manual
	makeindex manual.idx
	pdflatex manual

../Manual.pdf: manual.pdf
	rm -f $@
	cp $< $@

../markdown_syntax.html: markdown_syntax.md
	$(MD2PDF) -t "Markdown Syntax" --html -o "$@" "$<"

# format installation description as HTML page
../INSTALL.html: ../../INSTALL.md
	$(MD2PDF) -t "PAKCS Installation Instructions" --html -o "$@" "$<"

# format repository installation description as HTML page
../GITINSTALL.html: ../../GITINSTALL.md
	$(MD2PDF) -t "PAKCS Repository" --html -o "$@" "$<"

# format release notes as HTML page
../RELNOTES.html: ../../RELNOTES.md
	$(MD2PDF) -t "PAKCS Release Notes" --html -o "$@" "$<"

# format Curry style guide as HTML page
../CurryStyleGuide.html: tooldocs/casc/curry-style-guide.md
	cd tooldocs/casc && $(MAKE)
ifeq ($(CI_BUILD),yes)
	cp tooldocs/casc/curry-style-guide.html $@
else
	@if [ -f "tooldocs/casc/curry-style-guide.html" ] ; then cp tooldocs/casc/curry-style-guide.html $@ ; fi
endif

# generate documentation for all libraries
.PHONY: libdoc
libdoc:
	@cd ../../lib && $(MAKE) texdoc

.PHONY: install
install:
	$(MAKE) ../markdown_syntax.html
	$(MAKE) ../INSTALL.html
	$(MAKE) ../GITINSTALL.html
	$(MAKE) ../RELNOTES.html
	$(MAKE) ../CurryStyleGuide.html
	$(MAKE) libdoc
	$(MAKE) ../Manual.pdf

.PHONY: clean
clean:
	rm -f markdown_syntax.tex ../markdown_syntax.html \
	           ../INSTALL.html ../GITINSTALL.html ../RELNOTES.html
	rm -f *.aux *.bbl *.blg *.idx *.ilg *.ind *.log *.out *.pdf *.toc *.tpt
	rm -rf lib
	rm -f ../Manual.pdf ../Manual.ps.gz thumb* version.tex

=== docs/src/tooldocs/casc/Makefile ===
default: curry-style-guide.html

# Generate an HTML version of the style guide.
curry-style-guide.html: curry-style-guide.md style.html
ifeq ($(shell which pandoc > /dev/null ; echo $$?),0)
	pandoc -s -N --toc -H style.html -o $@ $<
else ifeq ($(CI_BUILD), yes)
	$(error "pandoc not found, can't generate Curry style description")
else
	@echo "WARNING: pandoc not found, Curry style description not generated"
endif

=== debian/changelog ===
pakcs (3.3.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Update versioned B-Ds and Ds for PAKCS components.
    + Bump Standards-Version: to 4.5.1. No changes needed.
  * debian/watch:
    + Update format version to 4.
  * debian/pakcs.install:
    + Update for renamed documentation files.
  * debian/pakcsinitrc:
    + Drop file. Not required anymore.
  * debian/rules:
    + Fix +DEB_DH_INSTALLCHANGELOGS_ARGS with correct (renamed) RELNOTES.md
      file name.
    + Drop some chmod operations for files that are gone in this release.
    * Adapt various file tweask to new upstream release.
    + Move more doc files to /usr/share/doc and symlink.
  * debian/pakcs.manpages:
    + Don't ship runcurry.1 man page. Binary has vanished in this upstream
      release.
  * debian/copyright:
    + Add auto-generated copyright.in template file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 04 Feb 2021 17:43:47 +0100

pakcs (2.2.0-2) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Make sure we rebuild against curry-frontend (>= 1.0.4-5~).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 29 Sep 2020 17:42:57 +0200

=== debian/control ===
Source: pakcs
Section: devel
Priority: optional
Maintainer: Debian Curry Maintainers <pkg-curry-maintainers@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Michael Hanus <mh@informatik.uni-kiel.de>,
Build-Depends: cdbs,
 debhelper (>= 10~),
 quilt,
 curry-frontend (>= 2.0.0~),
 curry-libs-source (>= 3.0.0~),
 curry-tools-source (>= 3.3.0~),
 swi-prolog-nox (>= 7.4),
 sqlite3,
 lockfile-progs,
 rdfind,
 symlinks,
Standards-Version: 4.5.1
Homepage: https://www-ps.informatik.uni-kiel.de/~pakcs/
Vcs-Browser: https://salsa.debian.org/pkg-curry-team/pakcs
Vcs-Git: https://salsa.debian.org/pkg-curry-team/pakcs.git

Package: pakcs
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 curry-frontend (>= 2.0.0~),
 swi-prolog-nox (>= 7.4),
 lockfile-progs,
Recommends:
 sqlite3,
Suggests:
 tk
Description: Portland Aachen Kiel Curry Compiler
 PAKCS is an implementation of the multi-paradigm declarative language
 Curry jointly developed by the Portland State University, the Aachen
 University of Technology, and the University of Kiel. Although this is
 not a highly optimized implementation but based on a high-level
 compilation of Curry programs into Prolog programs, it is not a toy
 implementation: PAKCS has been used for a variety of applications so far
 (e.g., graphical programming environments, an object-oriented front-end
 for Curry, partial evaluators, database applications, HTML programming
 with dynamic web pages, prototyping embedded systems). The size of all
 current Curry applications implemented with PAKCS amounts to more than
 150,000 lines (or 8 mbytes) of program code.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

VERBOSE=1

DISTPKGINSTALL=yes
CURRYFRONTEND=/usr/bin/curry-frontend
CURRYLIBSDIR=$(CURDIR)/debian/build/curry-libs
CURRYTOOLSDIR=$(CURDIR)/debian/build/curry-tools
PAKCSINSTALLDIR=/usr/lib/pakcs

# Only run unit tests on 64bit architectures for the reason given below.
#
# Quoting... http://www.swi-prolog.org/pldoc/man?section=64bits
#
# First of all, SWI-Prolog's addressing of the Prolog stacks does not
# cover the whole address space due to the use of type tag bits and
# garbage collection flags. On 32-bit hardware the stacks are limited to
# 128 MB each. This tends to be too low for demanding applications on
# modern hardware. On 64-bit hardware the limit is 2^32 times higher,
# exceeding the addressing capabilities of today's CPUs and operating
# systems. This implies Prolog can be started with stack sizes that use
# the full capabilities of your hardware.

ifeq (,$(filter 32,$(DEB_HOST_ARCH_BITS)))
DEB_MAKE_CHECK_TARGET = runtestverbose
else
DEB_MAKE_CHECK_TARGET =
endif
DEB_MAKE_BUILD_TARGET = all DISTPKGINSTALL=$(DISTPKGINSTALL) CURRYFRONTEND=$(CURRYFRONTEND) CURRYLIBSDIR=$(CURRYLIBSDIR) CURRYTOOLSDIR=$(CURRYTOOLSDIR) PAKCSINSTALLDIR=$(PAKCSINSTALLDIR)
DEB_MAKE_CLEAN_TARGET = cleanall

DEB_DH_INSTALLCHANGELOGS_ARGS = RELNOTES.md

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

pre-build::
	# obtain lib-trunk folder content...
	if [ ! -d "debian/build/curry-libs" ]; then \
	    mkdir -p debian/build/curry-libs/; \
	    cd debian/build/curry-libs && tar xf /usr/src/curry-libs-source.tar.xz && cd - 1>/dev/null; \
	fi

	# obtain currytools folder content...
	if [ ! -d "debian/build/curry-tools" ]; then \
	    mkdir -p debian/build/curry-tools/; \
	    cd debian/build/curry-tools && tar xf /usr/src/curry-tools-source.tar.xz && cd - 1>/dev/null; \
	fi

	sed -i "$(CURRYTOOLSDIR)/cpm/Makefile" -e "s@packagePath\ =\ .*\"@packagePath\ =\ \\\\\"/usr/lib/pakcs/currytools/cpm\\\\\"\"@"

	# make sure cleancurry is available in PAKCSHOME/bin, required for test suite
	mkdir -p bin/
	ln -fs ../scripts/cleancurry.sh bin/cleancurry

binary-post-install/pakcs::
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/cleancurry
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs-fcypp
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/*.sh
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/makesavedstate

	# unset PAKCSBUILDDIR, only support PAKCSINSTALLDIR
	for script in  debian/pakcs/usr/lib/pakcs/bin/pakcs debian/pakcs/usr/lib/pakcs/bin/pakcs-fcypp; do \
		sed -i "$$script" -e "s|^PAKCSBUILDDIR=.*$$|PAKCSBUILDDIR=\"<unset>\"|"; \
	done

	# similarly for buildDir Prolog variable
	for script in debian/pakcs/usr/lib/pakcs/src/pakcsversion.pl; do \
		sed -i "$$script" -e "s|buildDir('.*')|buildDir('<unset>')|g"; \
	done

	# remove superfluous LICENSE files
	find debian/pakcs/usr/lib/pakcs/currytools/ -type f -name LICENSE -delete

	cd $(CURDIR)/debian/pakcs/usr/share/doc/pakcs/docs && tar --clamp-mtime --mtime="$(SOURCE_DATE)" --mode=go=rX,u+rw,a-s --sort=name -cv -v -z -f $(CURDIR)/debian/pakcs/usr/share/doc/pakcs/curry-docs.tar.gz * && cd - 1>/dev/null
	rm -Rv debian/pakcs/usr/share/doc/pakcs/docs/

	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/docs/currysystem_manual.tex
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/docs/manual.tex
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/docs/README.txt
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/Implementation.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/src/CPM/Repository/README.txt
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/src/CPM/Repository/RepositoryDB_SQLCode.info
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/abstract-curry/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/boxes/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass-analysis/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Demand.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Deterministic.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Functional.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Groundness.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/HiOrderConstr.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/HiOrderFunc.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/HiOrderType.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Indeterministic.md
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/vendor/cass/docs/main.tex
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/vendor/cass/docs/manual.tex
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/NDEffect.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/NonDetAllDeps.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/NonDetDeps.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Overlapping.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/PatComplete.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Productive.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/README.txt
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RequiredValue.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RequiredValues.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Residuation.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RightLinear.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RootCyclic.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RootReplaced.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/SensibleType.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/SiblingCons.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/SolComplete.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Terminating.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Total.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/TypesInValues.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/UnsafeModule.md
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/vendor/cass/Protocol.txt
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cdbi/README.md
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/vendor/containers/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/csv/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/currypath/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/det-parse/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/execpath/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/flatcurry/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/frontend-exec/README.md
	debian/move2docs_and_symlink.sh  usr/lib/pakcs/currytools/cpm/vendor/global/README.md
	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/json/README.md

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg[0-9]*//,filenamemangle=s/.*\/pakcs-v(\d\S+)\.tar\.gz/pakcs-$1\.tar\.gz/g \
  https://git.ps.informatik.uni-kiel.de/curry/pakcs/tags?sort=updated_desc .*/archive/v?(\d\S+)\/.*.tar\.gz
